#include <string.h>
#include "msIoGeneric.h"
#include "msioCamera.h"
#include "msioGPS.h"
#include "printf.h"
#include "msioLL.h"
#include "msioHL.h"
#include "timer.h"
#include "util.h"

//MSIO regs
#define MSIO_REG_INT				0x01
#define MSIO_REG_TYPE				0x04
#define MSIO_REG_IFACE				0x05
#define MSIO_REG_CATEGORY			0x06
#define MSIO_REG_CLASS				0x07
#define MSIO_REG_ATTRLEN_HI			0x09
#define MSIO_REG_ATTRLEN_LO			0x0A







bool msIoGenericIsMSIO(const uint8_t *firstEightRegs)
{
	return firstEightRegs[MSIO_REG_TYPE] == 0x00;
}

void msIoGenericDemo(void)
{
	uint8_t funcsFound[8], func, readback;
	uint_fast8_t nFuncs = 0;
	
	if (!msioHlSetRegAddrs(MSIO_REG_CATEGORY, 1, MSIO_REG_CATEGORY, 1)) {
		
		pr("cannot set reg addrs\n");
		return;
	}
	
	for (func = 1; func < 0xff; func++) {
		
		pr("s %02xh\r", func);
		
		if (!msioHlRegsWrite(&func, 1)) {
			pr("cannot write\n");
			return;
		}
		if (!msioHlRegsRead(&readback, 1)) {
			pr("cannot read\n");
			return;
		}
		if (readback == func) {
			pr("Found function %02xh\n", func);
			if (nFuncs < sizeof(funcsFound))
				funcsFound[nFuncs] = func;
			nFuncs++;
		}
	}
	
	if (nFuncs)
		pr("IO stick with %u functions\n", nFuncs);
	else
		pr("IO stick with no recognizable functions!\n");
	
	if (nFuncs && funcsFound[0] == MSIO_CAM_FUNCTION) {
		
		func = MSIO_CAM_FUNCTION;
		if (!msioHlRegsWrite(&func, 1)) {
			pr("cannot write\n");
			return;
		}
		
		msioCameraDemo();
	}
	else if (nFuncs && funcsFound[0] == MSIO_GPS_FUNCTION) {
		
		func = MSIO_GPS_FUNCTION;
		if (!msioHlRegsWrite(&func, 1)) {
			pr("cannot write\n");
			return;
		}
		
		msioGpsDemo();
	}
}