#ifndef _MSIO_LL_H_
#define _MSIO_LL_H_

#include <stdbool.h>
#include <stdint.h>


//TPCs
#define MS_RD_LDATA					0x02
#define MS_RD_SDATA					0x03		//might not work on non-PRO MSs
#define MS_RD_REG					0x04
#define MS_GET_INT					0x07
#define MS_SET_RW_REG_ADRS			0x08
#define MS_EX_SET_CMD				0x09		//might not work on non-PRO MSs
#define MS_WR_REG					0x0b
#define MS_WR_SDATA					0x0c		//might not work on non-PRO MSs
#define MS_WR_LDATA					0x0d
#define MS_SET_CMD					0x0e


void msioLlInit(void);
bool msioLlTpcR(uint_fast8_t tpc, void *dst, uint_fast16_t len);
bool msioLlTpcW(uint_fast8_t tpc, const void *src, uint_fast16_t len);
bool msioLlTpcRex(uint_fast8_t tpc, void *dst, uint_fast16_t len, uint32_t maxTicksWait);
bool msioLlTpcWex(uint_fast8_t tpc, const void *src, uint_fast16_t len, uint32_t maxTicksWait);
bool msioLlGetInt(void);


#endif
